﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*ADO demo.  Based on a PureDispHelper example by Kiffi.
;*Create and read a MDB database.
;/////////////////////////////////////////////////////////////////////////////////

XIncludeFile "adoconstants.pbi"

IncludePath "..\..\"
XIncludeFile "COMatePLUS.pbi"

Define.COMateObject adoCatalog, adoTable, adoColumn, adoConnection, adoRecordSet

;Create a new MDB database.
;==========================
  databaseName$ = "ado.mdb"
  connectionString$ = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + databaseName$ + ";Jet OLEDB:Engine Type=5;"
  If FileSize(Databasename$) > 0
    DeleteFile(Databasename$)
  EndIf
  ;Create an ADOX (ADO extension) object used for working with databse schemas etc.
    adoCatalog = COMate_CreateObject("ADOX.Catalog")
  If adoCatalog
    ;Now attempt to create the database.
      If adoCatalog\Invoke("Create('" + connectionString$ + "')") = #S_OK
        adoTable = COMate_CreateObject("ADOX.Table")
        If adoTable
          ;Give the table a name
            adoTable\SetProperty("Name = 'TestTable'")
          ;Append table to catalog
            adoCatalog\Invoke("Tables\Append(" + Str(adoTable) + " as COMateObject)")
          ;Create an ID-Column with Autoincrement
            adoColumn = COMate_CreateObject("ADOX.Column")
            If adoColumn
              adoColumn\SetProperty("ParentCatalog = " + Str(adoCatalog) + " as COMateObject")
              adoColumn\SetProperty("Name = 'ID'")
              adoColumn\SetProperty("Type = " + Str(#adInteger))
              adoColumn\SetProperty("Properties('Autoincrement') = #True")
              ;Append the new column to the table
                adoTable\Invoke("Columns\Append(" + Str(adoColumn) + " as COMateObject)")
              ;Create and append some more columns
                adoTable\Invoke("Columns\Append('IntegerField', " + Str(#adInteger) + ")")
                adoTable\Invoke("Columns\Append('TextField', " + Str(#adVarWChar) + ")")
                adoTable\Invoke("Columns\Append('MemoField', " + Str(#adLongVarWChar) + ")")
              adoColumn\Release()
              MessageRequester("COMate - ADO demo", "Database created, table and 4 columns added!")
              ;Now add some records. To do this we create an ADO connection object which can be used to work with SQL.
                adoConnection = COMate_CreateObject("ADODB.Connection")
                If adoConnection
                  If adoConnection\Invoke("Open('" + connectionString$ + "')") = #S_OK
                    ;Insert some records.
                    ;Note that since the SQL statement is to contain single quotes (which will interfere with COMate), we must use
                    ;the $0027 escape sequence instead.
                      For Counter = 0 To 99
                        SQL$ = "Insert Into TestTable (IntegerField, TextField, MemoField) Values (" + Str(Counter) + ", $0027Text" + Str(Counter) + "$0027, $0027Memo" + Str(Counter) + "$0027)"
                        adoConnection\Invoke("Execute('" + SQL$ + "')")
                      Next
                    If COMate_GetLastErrorCode() = #S_OK
                      MessageRequester("COMate - ADO demo", "100 records added!"+#CRLF$+#CRLF$+"Press OK to retrieve these records!")
                      ;Retrieve the data.
                        SQL$ = "Select * from TestTable"
                        adoRecordSet = adoConnection\GetObjectProperty("Execute('" + SQL$ + "')")
                      If adoRecordSet
                        Repeat
                          EOF = adoRecordSet\GetIntegerProperty("EOF")
                          If EOF = -1  ;Variant_TRUE
                            Break
                          EndIf
                          ID$ = adoRecordSet\GetStringProperty("Fields(0)\Value")
                          Integer$ = adoRecordSet\GetStringProperty("Fields('IntegerField')\Value")
                          Text$ = adoRecordSet\GetStringProperty("Fields('TextField')\Value")
                          Memo$ = adoRecordSet\GetStringProperty("Fields('MemoField')\Value")
                          Debug "(ID=" + ID$ + ", IntegerField=" + Integer$ + ", TextField=" + Text$ + ", MemoField=" + Memo$ + ")"
                          adoRecordSet\Invoke("MoveNext")
                        ForEver
                        adoRecordSet\Invoke("Close")
                        adoRecordSet\Release()
                      Else
                        MessageRequester("COMate - ADO demo", "Couldn't create the recordset object!")
                      EndIf                
                    Else
                      MessageRequester("COMate - ADO demo", "There was a problem adding the records!")
                    EndIf                
                  Else
                    MessageRequester("COMate - ADO demo", "Couldn't create open the connection!")
                  EndIf        
                  adoConnection\Invoke("Close")
                  adoConnection\Release()
                Else
                  MessageRequester("COMate - ADO demo", "Couldn't create a connection object!")
                EndIf
            Else
              MessageRequester("COMate - ADO demo", "Couldn't create a new column object!")
            EndIf
          adoTable\Release()
        Else
          MessageRequester("COMate - ADO demo", "Couldn't create a new table!")
        EndIf
      Else
        MessageRequester("COMate - ADO demo", "Couldn't create the database!")
      EndIf
    adoCatalog\Release()
  Else
    MessageRequester("COMate - ADO demo", "Couldn't create the ADOX extension object!"+#CRLF$+#CRLF$+"ADO version 2.1 or higher is required! You need to install the latest version of MDAC.")
  EndIf



; IDE Options = PureBasic 4.31 Beta 1 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 18
; FirstLine = 18
; EnableUnicode
; EnableThread
; Executable = nxReportU.dll