﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*Prevent link opening in a new tab/window in the web-gadget demo.
;*
;*Note that we use the 'NewWindow3' event of the DWebBrowserEvents2. More control can be exacted by using the 'NewWindow3' event instead.
;/////////////////////////////////////////////////////////////////////////////////


IncludePath "..\"
XIncludeFile "COMatePLUS.pbi"

Define browser.COMateObject

DisableExplicit

URL$ = "http://www.mathsguru.co.uk" ;Try clicking the 'Acrobat reader' link which would normally open a new window.

#WebGadget = 0


;-BROWSER CALLBACK.

;/////////////////////////////////////////////////////////////////////////////////
;The following is the event procedure for our browser object.
;We use this in order to prevent new windows being opened from our web-gadget.
Procedure BrowserEventProc(Object.COMateObject, eventName$, parameterCount) 
  Protected *ptrBoolean.WORD
  If eventName$ = "NewWindow3"
    ;The second parameter for this event is a boolean passed by reference which we simply set to #True to cancel the navigation.
      If Object\IsEventParamPassedByRef(2, @*ptrBoolean)
        ;Cancel the navigation.
          *ptrBoolean\w = #VARIANT_TRUE
          MessageRequester("COMatePLUS demo!", "Prevented link opening in a new tab/window : " + Object\GetStringEventParam(5))
      EndIf
  EndIf
EndProcedure 
;/////////////////////////////////////////////////////////////////////////////////


If OpenWindow(0, 0, 0, 800, 600, "WebGadget - cancel pop-ups", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  WebGadget(#WebGadget, 0, 0, WindowWidth(0),WindowHeight(0), URL$) 
  browser = COMate_WrapCOMObject(GetWindowLong_(GadgetID(#WebGadget), #GWL_USERDATA)) 
  If browser
    ;Set the 'global' event handler for the browser object.
    ;We wish to trap the "NewWindow3" event which means that we must use the DWebBrowserEvents2 out-going interface.
    ;In order to over-ride COMatePLUS' selection of 'connection point' we pass a pointer to the IID of the DWebBrowserEvents2 out-going interface
    ;within the second optional parameter.
      If COMate_GetIIDFromName("DWebBrowserEvents2", @iid.IID) = #S_OK
        browser\SetEventHandler(#COMate_CatchAllEvents, @BrowserEventProc(), 0, iid)
      Else
        MessageRequester("COMatePLUS -web demo", "IID for the DWebBrowserEvents2 interface was not found on this system!" + #CRLF$ + #CRLF$ + "Try registering the 'Shdocvw.dll' library (you can use REGSVR32.EXE) to see if this fixes the problem.")     
      EndIf

    Repeat 
      Event = WaitWindowEvent(); 
      Select Event 
        Case #PB_Event_CloseWindow 
          Break 
      EndSelect 
    ForEver 
    browser\Release()
  Else
    MessageRequester("COMatePLUS - prevent link opening in a new tab/window demo", "Couldn't create the browser object!")
  EndIf
EndIf  


; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 29
; FirstLine = 17
; Folding = -
; EnableUnicode
; EnableThread
; Executable = dd.exe