﻿;/////////////////////////////////////////////////////////////////////////////////
;***COMate***  COM automation through iDispatch.
;*===========
;*
;*RegEXP 1000000 replacements demo.
;*
;*This somewhat superficial demo uses VBScripts RegEXP engine and offers up 1000000 string replacements using 'pre-compiled
;*statements' added to COMatePLUS.
;*The idea is to compare the time taken with the equivalent demo which does NOT use pre-compiled statements.
;*
;*ENSURE THE DEBUGGER IS DISABLED!
;/////////////////////////////////////////////////////////////////////////////////

DisableDebugger


IncludePath "..\..\"
XIncludeFile "COMatePLUS.pbi"

;Prepare our statement for replacing a string etc.
;=================================================
  hStatement = COMate_PrepareStatement("Replace('The quick brown fox jumped over the lazy dog.', 'cat')")
  If hStatement = 0
    MessageRequester("COMatePLUS - RegEXP 1000000 string replacements demo", "Couldn't create the statement!" + #CRLF$ + #CRLF$ + "COMatePLUS error : " + COMate_GetLastErrorDescription())
    End
  EndIf


regExObject.COMateObject = COMate_CreateObject("VBScript.RegExp")
If regExObject
  regExObject\SetProperty("Pattern = 'fox'")
  regExObject\SetProperty("IgnoreCase = #True")
  regExObject\SetProperty("Global = #True") ;No boolean type modifier required here.
  MessageRequester("COMatePLUS - RegEXP 1000000 string replacements demo", "Click OK to begin.")
  StartTime = ElapsedMilliseconds()
  For i = 1 To 1000000
    ;Execute the pre-compiled statement.
      szResult.s = regExObject\GetStringProperty("", hStatement)
  Next
  EndTime = ElapsedMilliseconds() - StartTime
  MessageRequester("COMatePLUS - RegEXP 1000000 string replacements demo", "1000000 replacements achieved in " + Str(EndTime) + " milliseconds.")
  regExObject\Release()
Else
  MessageRequester("COMatePLUS - RegEXP 1000000 string replacements demo", "Couldn't create the application object!")
EndIf


;Free our statement.
;===================
  COMate_FreeStatementHandle(hStatement)



; IDE Options = PureBasic 4.30 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 40
; FirstLine = 8
; Folding = -
; EnableUnicode
; Executable = nxReportU.dll
; DisableDebugger